// @mui
import { Box, Button, Card, Collapse, IconButton, InputLabel, MenuItem, OutlinedInput, Paper, Grid, Select, SelectChangeEvent, Table, TableBody, TableCell, TableContainer, TableHead, TableRow, TextField, Typography, Badge, Tab, Tabs, CardHeader, Stack, Menu, ButtonGroup, Pagination } from '@mui/material';
import KeyboardArrowDownIcon from '@mui/icons-material/KeyboardArrowDown';
import KeyboardArrowRightIcon from '@mui/icons-material/KeyboardArrowRight';
import AddIcon from '@mui/icons-material/Add';
import UploadIcon from '@mui/icons-material/Upload';
import CancelIcon from '@mui/icons-material/Cancel';
// hooks
import React, { ChangeEvent, Component, useEffect, useRef, useState } from 'react';
import useSettings from '../../../hooks/useSettings';
import { useNavigate, useParams, useSearchParams } from 'react-router-dom';
// components
import axios from '../../../utils/axios';
import { LaravelPaginatedData } from '../../../@types/paginated-data';
import { Icd } from '../../../@types/diagnosis';
import BasePagination from '../../../components/BasePagination';

export default function List() {
  const navigate = useNavigate();
  const { themeStretch } = useSettings();
  const { corporate_id } = useParams();
  const [searchParams, setSearchParams] = useSearchParams();
  const [importResult, setImportResult] = useState(null);
  
  function SearchInput(props: any) {
     // SEARCH
    const searchInput = useRef<HTMLInputElement>(null);
    const [searchText, setSearchText] = useState("");

    const handleSearchChange = (event: any) => {
      const newSearchText = event.target.value ?? ''
      setSearchText(newSearchText);
    }

    const handleSearchSubmit = (event: any) => {
      event.preventDefault();
      props.onSearch(searchText); // Trigger to Parent
    }

    useEffect(() =>  { // Trigger First Search
      setSearchText(searchParams.get('search') ?? '');
    }, [searchParams])

    return (
      <form onSubmit={handleSearchSubmit} style={{ width: '100%' }}>
        <TextField id="search-input" ref={searchInput} label="Search" variant="outlined" fullWidth onChange={handleSearchChange} value={searchText}/>
      </form>
    );
  }

  function ImportForm(props: any) {
    // IMPORT
    // Create Button Menu
    const [anchorEl, setAnchorEl] = React.useState<null | HTMLElement>(null);
    const createMenu = Boolean(anchorEl);
    const importForm = useRef<HTMLInputElement>(null) 
    const [currentImportFileName, setCurrentImportFileName] = useState(null)

    const handleClick = (event: React.MouseEvent<HTMLButtonElement>) => {
      setAnchorEl(event.currentTarget);
    };

    const handleClose = () => {
      setAnchorEl(null);
    };

    const handleImportButton = () => {
      if (importForm?.current) {
        handleClose();
        importForm.current ? importForm.current.click() : console.log('No File selected');
      } else {
        alert('No file selected')
      }
    }

    const handleCancelImportButton = () => {
      importForm.current.value = "";
      importForm.current.dispatchEvent(new Event("change", { bubbles: true }));
    }

    const handleGetTemplate = (type :string) => {
      axios.get('corporates/import-document-example/' + type)
        .then((response) => {
          const link = document.createElement('a');
          link.href = response.data.data.file_url;
          link.setAttribute('download', response.data.data.file_name);
          document.body.appendChild(link);
          link.click();
          handleClose();
        })
    }

    const handleImportChange = (event: any) => {
      if (event.target.files[0]) {
        setCurrentImportFileName(event.target.files[0].name)
      } else {
        setCurrentImportFileName(null);
      }
    }

    const handleFormulariumList = async (appliedFilter = null) => {
      axios.get(`corporates/${corporate_id}/formulariums/list`).then((response) => {
        const link = document.createElement('a');
        link.href = response.data.data.file_url;
        link.setAttribute('download', response.data.data.file_name);
        document.body.appendChild(link);
        link.click();
        handleClose();
        enqueueSnackbar('Download Success', { variant: 'succes' })
      })
      .catch(response => {
        enqueueSnackbar('Looks like something went wrong. Please check your data and try again. ' + response.message, { variant: 'error' })
      })
      ;
    }

    const handleUpload = () => {
      if (importForm.current?.files.length) {
        const formData = new FormData();
        formData.append("file", importForm.current?.files[0])
        axios.post(`corporates/${corporate_id}/formulariums/import`, formData )
          .then(response => {
            handleCancelImportButton();
            loadDataTableData();
            setImportResult(response.data)
            // alert('Succesfully read '+ response.data.total_successed_row + ' with ' + response.data.total_failed_row + ' failed rows');
          })
          .catch(response => {
            enqueueSnackbar('Looks like something went wrong. Please check your data and try again. ' + response.message, { variant: 'error' })
          })
      } else {
        enqueueSnackbar('No File Selected', { variant: 'warning' })
      }
    }
    
    return (
      <div>
        <input type='file' id='file' ref={importForm} style={{ display: 'none' }} onChange={handleImportChange} accept=".csv, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel, text/plain" />
        {( !currentImportFileName && <Stack direction={'row'} spacing={2} sx={{ p: 2 }}>
          <SearchInput onSearch={applyFilter}/>
          {/* <h1>kjasndkjandskjasndkjansdkjansd</h1> */}
          <Button
              id="import-button"
              variant='outlined'
              startIcon={<AddIcon />} sx={{ p: 1.8 }}
              aria-controls={createMenu ? 'basic-menu' : undefined}
              aria-haspopup="true"
              aria-expanded={createMenu ? 'true' : undefined}
              onClick={handleClick}
            >
              Import
            </Button>
            <Menu
              id="import-button"
              anchorEl={anchorEl}
              open={createMenu}
              onClose={handleClose}
              MenuListProps={{
                'aria-labelledby': 'basic-button',
              }}
            >
              {/* <MenuItem onClick={() => {navigate(`/master/formularium/create/${formularium_template_id}`)} }>Create</MenuItem> */}
              <MenuItem onClick={handleImportButton}>Import</MenuItem>
              <MenuItem onClick={() => {handleGetTemplate('master-formularium-corporate')}}>Download Template</MenuItem>
              <MenuItem onClick={handleFormulariumList}>Download Formularium</MenuItem>
            </Menu>
        </Stack>
        )}

        {( currentImportFileName && <Stack direction={'row'} spacing={2} sx={{ p: 2 }}>
          <ButtonGroup variant="outlined" aria-label="outlined button group" fullWidth>
            <Button onClick={handleImportButton} fullWidth>{currentImportFileName ?? "No File Selected"}</Button>
            <Button onClick={handleCancelImportButton} size="small" fullWidth={false} sx={{ p: 1.8 }}><CancelIcon color="error"/></Button>
          </ButtonGroup>

          <Button
            id="upload-button"
            variant='outlined'
            startIcon={<UploadIcon />} sx={{ p: 1.8 }}
            onClick={handleUpload}
          >
            Upload
          </Button>
        </Stack>
        )}
        {( importResult && 
        <Stack direction={'row'} sx={{ px: 2, pb: 2 }}>
          <Box sx={{ color: "text.secondary" }}>Last Import Result Report : <a href={importResult.result_file?.url ?? "#"}>{importResult.result_file?.name ?? "-"}</a></Box>
        </Stack>
        )}
      </div>
    );
  }

  // Called on every row to map the data to the columns
  function createData( icd: Icd ): Icd {
    return {
      ...icd,
    }
  }

  // Generate the every row of the table
  function Row(props: { row: ReturnType<typeof createData> }) {
    const { row } = props;
    const [open, setOpen] = React.useState(false);

    return (
      <React.Fragment>
        <TableRow sx={{ '& > *': { borderBottom: 'unset' } }}>
          <TableCell>
            <IconButton
              aria-label="expand row"
              size="small"
              onClick={() => setOpen(!open)}
            >
              {open ? <KeyboardArrowDownIcon /> : <KeyboardArrowRightIcon />}
            </IconButton>
          </TableCell>
          <TableCell align="left">{row.code}</TableCell>
          <TableCell align="left">{row.atc_code}</TableCell>
          <TableCell align="left">{row.name}</TableCell>
          <TableCell align="left">{row.category_name}</TableCell>
          <TableCell align="left">{row.uom}</TableCell>
          <TableCell align="left">{row.active}</TableCell>

          {/* <TableCell align="right"><Button variant="outlined" color="success" size="small">Active</Button></TableCell>
          <TableCell align="right"><Button variant="outlined" color="error" size="small">Disable</Button></TableCell> */}
        </TableRow>
        {/* COLLAPSIBLE ROW */}
        <TableRow>
          <TableCell />
          <TableCell style={{ paddingBottom: 0, paddingTop: 0 }} colSpan={15}>
            <Collapse in={open} timeout="auto" unmountOnExit>
              <Box sx={{ pb: 2 }}>
                <Typography sx={{ fontWeight: '600', mb: 1 }}>Detail</Typography>
                <Grid container sx={{ pb: 2, mb: 2, borderBottom: 1 }}>
                  <Grid item xs={6}>
                    <Grid container>
                      <Grid item xs={6}>
                        Description
                      </Grid>
                      <Grid item xs={6}>
                        : {row.description ?? '-'}
                      </Grid>
                      <Grid item xs={6}>
                        General Indication
                      </Grid>
                      <Grid item xs={6}>
                        : {row.general_indication ?? '-'}
                      </Grid>
                      <Grid item xs={6}>
                        Composition
                      </Grid>
                      <Grid item xs={6}>
                        : {row.composition ?? '-'}
                      </Grid>
                    </Grid>
                  </Grid>
                  <Grid item xs={6}>
                    <Grid container>
                      <Grid item xs={6}>
                        Kategori Obat
                      </Grid>
                      <Grid item xs={6}>
                        : {row.kategori_obat ?? '-'}
                      </Grid>
                      <Grid item xs={6}>
                        BPOM Registration
                      </Grid>
                      <Grid item xs={6}>
                        : {row.bpom_registration ?? '-'}
                      </Grid>
                      <Grid item xs={6}>
                        Classifications
                      </Grid>
                      <Grid item xs={6}>
                        : {row.classifications ?? '-'}
                      </Grid>
                      <Grid item xs={6}>
                        Cat For
                      </Grid>
                      <Grid item xs={6}>
                        : {row.cat_for ?? '-'}
                      </Grid>
                      <Grid item xs={6}>
                        Class
                      </Grid>
                      <Grid item xs={6}>
                        : {row.class ?? '-'}
                      </Grid>
                      <Grid item xs={6}>
                        Manufacturer
                      </Grid>
                      <Grid item xs={6}>
                        : {row.manufacturer ?? '-'}
                      </Grid>
                    </Grid>
                  </Grid>
                </Grid>
              </Box>
            </Collapse>
          </TableCell>
        </TableRow>
      </React.Fragment>
    );
  }

  // Dummy Default Data
  const [dataTableIsLoading, setDataTableLoading] = useState(true);
  const [dataTableLastRequest, setDataTableLastRequest] = useState(0);
  const [dataTableResponseState, setDataTableResponseState] = useState('idle');
  const [dataTableData, setDataTableData] = useState<LaravelPaginatedData>({
    current_page: 1,
    data: [],
    path: "",
    first_page_url: "",
    last_page: 1,
    last_page_url: "",
    next_page_url: "",
    prev_page_url: "",
    per_page: 10,
    from: 0,
    to: 0,
    total: 0
  });
  const [dataTablePage, setDataTablePage] = useState(5);

  const loadDataTableData = async (appliedFilter : any | null = null) => {
    setDataTableLoading(true);
    const filter = appliedFilter ? appliedFilter : Object.fromEntries([...searchParams.entries()]);
    const response = await axios.get(`corporates/${corporate_id}/formulariums`, { params: filter });
    // console.log(response.data);
    setDataTableLoading(false);

    setDataTableData(response.data);
  }

  const headStyle = {
    fontWeight: 'bold',
  };

  const applyFilter = async (searchFilter: string) => {
    await loadDataTableData({ "search" : searchFilter });
    setSearchParams({ "search" : searchFilter });
  }

  const handlePageChange = (event : ChangeEvent, value: number) => {
    const filter = Object.fromEntries([...searchParams.entries(), ["page", value]]);
    loadDataTableData(filter);
    setSearchParams(filter);
  }

  useEffect(() => {
    loadDataTableData();
  }, [])
  
  return (
    <Stack>
      <ImportForm />
        <Card>
        {/* The Main Table */}
        <TableContainer component={Paper}>
          <Table aria-label="collapsible table">
            <TableBody>
              <TableRow>
                <TableCell style={headStyle} align="left" />
                <TableCell style={headStyle} align="left">Code</TableCell>
                <TableCell style={headStyle} align="left">ATC Code</TableCell>
                <TableCell style={headStyle} align="left">Name</TableCell>
                <TableCell style={headStyle} align="left">Category Name</TableCell>
                <TableCell style={headStyle} align="left">UOM</TableCell>
                <TableCell style={headStyle} align="left">Status</TableCell>
              </TableRow>
            </TableBody>
            {dataTableIsLoading ?
              (
                <TableBody>
                  <TableRow>
                    <TableCell colSpan={8} align="center">Loading</TableCell>
                  </TableRow>
                </TableBody>
              ) : (
                dataTableData.data.length == 0 ? 
                (
                  <TableBody>
                    <TableRow>
                      <TableCell colSpan={8} align="center">No Data</TableCell>
                    </TableRow>
                  </TableBody>
                ) : (
                  <TableBody>
                    {dataTableData.data.map(row => (
                      <Row key={row.id} row={row} />
                    ))}
                  </TableBody>
                )
            )}
          </Table>
        </TableContainer>
        
        <BasePagination paginationData={dataTableData} onPageChange={handlePageChange}/>
        </Card>
    </Stack>
  );
}
